#include <iostream>
#include <vector>
#include <windows.h>
//#include "histogram_internal.h"
#include "histogram.h"

using namespace std;


bool
find_minmax(vector<double> numbers, double& min, double& max)
{
    if(numbers.size() == 0)
        return false;

    min = numbers[0];
    max = numbers[0];
    size_t number_count = numbers.size();
    for (size_t i = 1; i < number_count; i++)
    {
        if (numbers[i] < min)
        {
            min = numbers[i];
        }
        else if (numbers[i] > max)
        {
            max = numbers[i];
        }
    }
    return true;
}

vector<size_t>
make_histogram(const vector<double>& numbers, size_t bin_count)
{

    double min, max;
    vector<size_t> bins(bin_count);
    find_minmax(numbers, min, max);
    double bin_size = (max - min) / bin_count;
    size_t number_count = numbers.size();

    for (size_t i = 0; i < number_count; i++)
    {
        bool found = false;
        for (size_t j = 0; (j < bin_count - 1) && !found; j++)
        {
            auto lo = min + j * bin_size;
            auto hi = min + (j + 1) * bin_size;
            if ((lo <= numbers[i]) && (numbers[i] < hi))
            {
                bins[j]++;
                found = true;
            }
        }
        if (!found)
        {
            bins[bin_count - 1]++;
        }
    }
    return bins;
}
